function [GPS, INS_FLOW_INFO, INS, OT_ATT] = PprzLogReader_1_0_attitude(filename)

% ---------------PprzLogReader_1_0.m-----------------------------------
% PprzLogReader_1_0.m is for reading Paparazzi log file into the matlab 
% workspace. All the log data is converted into different matrice.  
% Author: Haiyang Chao 
% Date: 2009/04/11


%display('*******Log Reader for Paparazzi begins**************');

if(~exist('filename', 'var') || isempty(filename))
    error('Specify the filename.\n');
else
    fid = fopen(filename, 'r');
end

if fid == -1
    display('Error in opening the file! ');
    display('Please modify the script to give pprz log file name and directory.');
end

LineCount = 0; 
h=1;i=1;j=1;k=1;l=1;m=1;n=1;o=1;p = 1; q= 1;

OT_ATT = [];

while feof(fid) == 0
   tline = fgetl(fid);
   LineCount = LineCount+1;
   
   if  (length(strfind(tline, 'GPS_SOL'))) > 0    
       GPS_SOL(h,:) = textscan(tline,'%f %*d %*s %d %d %d %d',1);
       h = h+1;
       continue;
   else
       %  <message name="GPS_INT" id="155">
       %       <field name="ecef_x"  type="int32" unit="cm"   alt_unit="m"/>
       %       <field name="ecef_y"  type="int32" unit="cm"   alt_unit="m"/>
       %       <field name="ecef_z"  type="int32" unit="cm"   alt_unit="m"/>
       %       <field name="lat"     type="int32" unit="1e7deg" alt_unit="deg" alt_unit_coef="0.0000001"/>
       %       <field name="lon"     type="int32" unit="1e7deg" alt_unit="deg" alt_unit_coef="0.0000001"/>
       %       <field name="alt"     type="int32" unit="mm"   alt_unit="m">altitude above WGS84 reference ellipsoid</field>
       %       <field name="hmsl"    type="int32" unit="mm"   alt_unit="m">height above mean sea level (geoid)</field>
       %       <field name="ecef_xd" type="int32" unit="cm/s" alt_unit="m/s"/>
       %       <field name="ecef_yd" type="int32" unit="cm/s" alt_unit="m/s"/>
       %       <field name="ecef_zd" type="int32" unit="cm/s" alt_unit="m/s"/>
       %       <field name="pacc"    type="uint32" unit="cm"   alt_unit="m"/>
       %       <field name="sacc"    type="uint32" unit="cm/s" alt_unit="m/s"/>
       %       <field name="tow"     type="uint32"/>
       %       <field name="pdop"    type="uint16"/>
       %       <field name="numsv"   type="uint8"/>
       %       <field name="fix"     type="uint8" values="NONE|NA|2D|3D|DGPS|RTK"/>
       %       <field name="comp_id" type="uint8" values="NONE|UBX|NMEA|SIRF|SKYTRAQ|MTK|PIKSI|XSENS|DATALINK|UDP|ARDRONE2|SIM|MULTI|VECTORNAV|IMCU"/>
       %     </message>
       
        if ( length(strfind(tline, 'GPS')) ) > 0
            G = textscan(tline,'%f %*d %*s %d %d %d %d %d %d %d %d %d %d',1);
            GPS(i,:) = [G{1,1} G{1,7} G{1,2} G{1,3} G{1,4} G{1,5} G{1,6}];
            i = i+1;
            continue;
        end
   end
   
   if ( length(findstr(tline, 'PPRZ_MODE')) ) > 0
        PPRZ_MODE(j,:) = textscan(tline,'%4f32 %*d %*s %d %d %d %d %d %d');
        j=j+1;
        continue;
   end
   
   if ( length(findstr(tline, 'DESIRED')) ) > 0
        DESIRED(k,:) = textscan(tline,'%f %*d %*s %f %f %f %f %f %f %f',1);
        k=k+1;
        continue;
   end
   
   if ( length(findstr(tline, 'ATTITUDE'))  > 0  && ~length(findstr(tline, 'OPTITRACK_ATTITUDE'))  > 0 )
        ATTITUDE(l,:) = textscan(tline,'%f %*d %*s %d %d %d',1);
        l=l+1;
        continue;
   end 
    
   if  ( length(findstr(tline, 'NAVIGATION_REF')) ) == 0    
        if ( length(findstr(tline, 'NAVIGATION')) ) > 0
            NAVIGATION(m,:) = textscan(tline,'%f %*d %*s %d %d %d %d %f %f',1);
            m = m+1;
            continue;
        end
   else
        continue;
   end
   
   if ( length(findstr(tline, 'COMMANDS')) ) > 0
        COMMANDS(n,:) = textscan(tline,'%f %*d %*s %d,%d,%d,%*d',1);
        n=n+1;
        continue;
   end
   
   %     <message name="INS_FLOW_INFO" id="75">
   %       <field name="vy"  type="float" unit="m/s"/>          1   +1
   %       <field name="phi"  type="float" unit="deg"/>         2   +1
   %       <field name="p"  type="float" unit="deg/s"/>         3   ...
   %       <field name="vx"  type="float" unit="m/s"/>          4
   %       <field name="theta"  type="float" unit="deg"/>       5
   %       <field name="q"  type="float" unit="deg/s"/>         6
   %       <field name="z"  type="float" unit="m"/>             7
   %       <field name="vz"  type="float" unit="m/s"/>          8
   %       <field name="vy_GT"  type="float" unit="m/s"/>       9
   %       <field name="phi_GT"  type="float" unit="deg"/>      10
   %       <field name="p_GT"  type="float" unit="deg/s"/>      11
   %       <field name="vx_GT"  type="float" unit="m/s"/>       12
   %       <field name="theta_GT"  type="float" unit="deg"/>    13
   %       <field name="q_GT"  type="float" unit="deg/s"/>      14
   %       <field name="z_GT"  type="float" unit="m"/>          15
   %       <field name="vz_GT"  type="float" unit="m/s"/>       16
   %       <field name="thrust_bias"  type="float" unit="N"/>   17
   %       <field name="use_filter"  type="int32" unit="-"/>   18 
   %     </message>
   
   if ( length(findstr(tline, 'INS_FLOW_INFO')) ) > 0
        FD = textscan(tline,'%f %*d %*s %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %d',1);
        vv = [FD{1,1}];
        for i = 2:length(FD)
            vv = [vv, double(FD{1,i})];
        end
        INS_FLOW_INFO(o,:) = vv;
        INS_FLOW_INFO(o,8) = INS_FLOW_INFO(o,8) - 0.4;
        o=o+1;
        continue;
   end
   
   
   %
   %  <message name="ROTORCRAFT_FP" id="147">
   %       <field name="east"     type="int32" alt_unit="m" alt_unit_coef="0.0039063"/>
   %       <field name="north"    type="int32" alt_unit="m" alt_unit_coef="0.0039063"/>
   %       <field name="up"       type="int32" alt_unit="m" alt_unit_coef="0.0039063"/>
   %       <field name="veast"    type="int32" alt_unit="m/s" alt_unit_coef="0.0000019"/>
   %       <field name="vnorth"   type="int32" alt_unit="m/s" alt_unit_coef="0.0000019"/>
   %       <field name="vup"      type="int32" alt_unit="m/s" alt_unit_coef="0.0000019"/>
   %       <field name="phi"      type="int32" alt_unit="deg" alt_unit_coef="0.0139882"/>
   %       <field name="theta"    type="int32" alt_unit="deg" alt_unit_coef="0.0139882"/>
   %       <field name="psi"      type="int32" alt_unit="deg" alt_unit_coef="0.0139882"/>
   %       <field name="carrot_east"   type="int32" alt_unit="m" alt_unit_coef="0.0039063"/>
   %       <field name="carrot_north"  type="int32" alt_unit="m" alt_unit_coef="0.0039063"/>
   %       <field name="carrot_up"     type="int32" alt_unit="m" alt_unit_coef="0.0039063"/>
   %       <field name="carrot_psi"    type="int32" alt_unit="deg" alt_unit_coef="0.0139882"/>
   %       <field name="thrust"        type="int32"/>
   %       <field name="flight_time"   type="uint16" unit="s"/>
   %     </message>
   
   %        <message name="INS" id="198">
%       <field name="ins_x"     type="int32" alt_unit="m"    alt_unit_coef="0.0039063"/>
%       <field name="ins_y"     type="int32" alt_unit="m"    alt_unit_coef="0.0039063"/>
%       <field name="ins_z"     type="int32" alt_unit="m"    alt_unit_coef="0.0039063"/>
%       <field name="ins_xd"    type="int32" alt_unit="m/s"  alt_unit_coef="0.0000019"/>
%       <field name="ins_yd"    type="int32" alt_unit="m/s"  alt_unit_coef="0.0000019"/>
%       <field name="ins_zd"    type="int32" alt_unit="m/s"  alt_unit_coef="0.0000019"/>
%       <field name="ins_xdd"   type="int32" alt_unit="m/s2" alt_unit_coef="0.0009766"/>
%       <field name="ins_ydd"   type="int32" alt_unit="m/s2" alt_unit_coef="0.0009766"/>
%       <field name="ins_zdd"   type="int32" alt_unit="m/s2" alt_unit_coef="0.0009766"/>
%     </message>

   if ( length(findstr(tline, 'INS')) > 0 && length(findstr(tline, 'INS_REF')) == 0)
        I = textscan(tline,'%f %*d %*s %d %d %d %d %d %d %d %d %d');
        INS(p,:) = [I{1,1}, I{1,2}, I{1,3}, I{1,4}, I{1,5}, I{1,6}, I{1,7}];
        p=p+1;
        continue;
   end
   
   
   %     <message name="OPTITRACK_ATTITUDE" id="76">
   %       <field name="phi"  type="float" unit="deg/s"/>
   %       <field name="theta"  type="float" unit="deg"/>
   %       <field name="psi"  type="float" unit="deg/s"/>
   %       <field name="rigid_body_ID"  type="int32" unit="-"/>
   %     </message>
   if ( length(findstr(tline, 'OPTITRACK_ATTITUDE')) ) > 0
        ATT = textscan(tline,'%f %*d %*s %f %f %f %f',1);
        vv = [ATT{1,1}];
        for i = 2:length(ATT)
            vv = [vv, double(ATT{1,i})];
        end
        OT_ATT(q,:) = vv;
        q=q+1;
        continue;
   end
   
end

fclose(fid);
%display(LineCount);

%display('*******Log Reader for Paparazzi ends**************');