function ind = find_ind_for_time(T, time_in_secs)
% function ind = find_ind_for_time(T, time_in_secs)
%
% Find the index corresponding to a certain time.
% - T: a vector with times in seconds
% - time_in_secs: the time we want to search for
%
% - ind: the first index where T(ind) >= time_in_secs
%
% Article: 
% Accommodating unobservability to control flight attitude with optic flow
% G.C.H.E. de Croon, J.J.G. Dupeyroux, C. De Wagter, A. Chatterjee, D.A. Olejnik, F. Ruffier
%
% Code by:
% Guido de Croon | g.c.h.e.decroon@tudelft.nl

inds = find(T >= time_in_secs);
if(~isempty(inds))
    ind = inds(1);
else
    ind = [];
end