function fC = flatten_cell(C, axis)
% function fC = flatten_cell(C, axis)
%
% Takes a cell with values and flattens it into an array.
%
% Article: 
% Accommodating unobservability to control flight attitude with optic flow
% G.C.H.E. de Croon, J.J.G. Dupeyroux, C. De Wagter, A. Chatterjee, D.A. Olejnik, F. Ruffier
%
% Code by:
% Guido de Croon | g.c.h.e.decroon@tudelft.nl

if(~exist('axis', 'var') || isempty(axis)) 
    if(size(C{1}, 1) > size(C{1}, 2))
        axis = 1;
    else
        axis = 2;
    end
end

fC = [];
for i = 1:length(C)
    if(axis == 1)
        fC = [fC; C{i}];
    else
        fC = [fC, C{i}];
    end
end