function color = get_color_palette()
% function colors = get_color_palette()
%
% Get all colors for plotting different variables.
%
% Article: 
% Accommodating unobservability to control flight attitude with optic flow
% G.C.H.E. de Croon, J.J.G. Dupeyroux, C. De Wagter, A. Chatterjee, D.A. Olejnik, F. Ruffier
%
% Code by:
% Guido de Croon | g.c.h.e.decroon@tudelft.nl

color.gyro = [0.6 0.6 0.6];
color.gyro_head = [0.8 0.6 0.4];
color.flow = [0.4 0.4 0.4];
color.phi = [68, 120, 33] / 255.0;
color.phi_head = [33, 68, 120] / 255.0;
color.theta = [68, 120, 33] / 255.0;
color.theta_head = [33, 68, 120] / 255.0;
color.vy = [0, 102, 128] / 255.0;
color.vx = [0, 102, 128] / 255.0;
color.z = [170, 0, 68]/ 255.0;
color.bg = [1 1 1];
color.std_phi_robot = [0.4 0.4 0.4];
color.std_phi_bee = [0.8 0.8 0.0];
color.std_theta_robot = [0.4 0.4 0.4];
color.std_theta_bee = [0.8 0.8 0.0];
color.observability_sim = [102, 0, 102] / 255.0;
color.imu = [0.8, 0.8, 0.8];
color.optitrack = [0,0,0];