function kd = get_wing_drag_factor(phi_wings, kd0)
% function kd = get_wing_drag_factor(phi_wings, kd0)
%
% Article: 
% Accommodating unobservability to control flight attitude with optic flow
% G.C.H.E. de Croon, J.J.G. Dupeyroux, C. De Wagter, A. Chatterjee, D.A. Olejnik, F. Ruffier
%
% Code by:
% Guido de Croon | g.c.h.e.decroon@tudelft.nl

% As a flapping wing pitches more forward, it generates less drag:
kd = cos(phi_wings) * kd0;

