function print_metrics(metrics)
% function print_metrics(metrics)
%
% Prints the performance metrics.
%
% Article: 
% Accommodating unobservability to control flight attitude with optic flow
% G.C.H.E. de Croon, J.J.G. Dupeyroux, C. De Wagter, A. Chatterjee, D.A. Olejnik, F. Ruffier
%
% Code by:
% Guido de Croon | g.c.h.e.decroon@tudelft.nl

fprintf('MAE ground truth wrt reference (whole run): %f\n', metrics.MAE_GT);
fprintf('MAE observed signal wrt reference (whole run): %f\n', metrics.MAE);
fprintf('MAE ground truth wrt reference during last %d seconds: %f.\n', metrics.N_sec, metrics.MAE_GT_last_N_sec);
fprintf('MAE observed signal wrt reference during last %d seconds: %f.\n', metrics.N_sec, metrics.MAE_last_N_sec);
try
    fprintf('Rise time = %f.\n', metrics.rise_time);
    fprintf('Percentage overshoot = %f.\n', metrics.percentage_overshoot);
catch
end