function run_all()
% function run_all()
%
% Reproduce all figures and observability analyses related to the article: 
% Accommodating unobservability to control flight attitude with optic flow
% G.C.H.E. de Croon, J.J.G. Dupeyroux, C. De Wagter, A. Chatterjee, D.A. Olejnik, F. Ruffier
%
% Code by:
% Abhishek Chatterjee | abhishek.chaterjee002@gmail.com
% Guido de Croon | g.c.h.e.decroon@tudelft.nl

% Perform nonlinear observability analysis:
observability_analysis()

% Run all simulations for which the results were reported in the article:
run_simulations()

% Analyze the robotic experiments:
analyze_robotic_experiments()